#include "integer_Q.h"

int integer_queue[INTEGER_QUEUE_SIZE]; /* integer_queue_size() <= INTEGER_QUEUE_SIZE - 1 */
int integer_queue_begin, integer_queue_end;
int integer_ring_count;

static int BELL = 0x07;

int display_queue(void) {
    int item, k;
    int size = integer_queue_size();

    item = integer_queue_begin;
    for(k = 0; k < size; k++) {
        putchar(integer_queue[item]);
        item = next_integer(item);
    }

    return 0;
}

int empty_queue(void) {
    return integer_queue_begin == integer_queue_end;
}

int next_integer(int index) {
    return (index + 1) % INTEGER_QUEUE_SIZE;
}

int pop_frontal(void) {
    if( empty_queue() ) {
        return EMPTY_ERROR;
    }

    integer_queue[integer_queue_begin] = BELL;
    integer_queue_begin = next_integer(integer_queue_begin);
    return QUEUE_SHRUNK;
}

int prepare_ring_buffer(int size, int control) {
    int i;
    clearing();
    for(i = 0; i < size; ++i) {
        push_back_integer(control);
    }

    return integer_queue_size();
}

int push_back_integer(int q) {
    if( next_integer(integer_queue_end) == integer_queue_begin ) {
        return FULL_HOUSE_ERROR;
    }

    integer_queue[integer_queue_end] = q;
    integer_queue_end = next_integer(integer_queue_end);
    return QUEUE_GROWN;
}

int integer_queue_size(void) {
    int size;

    if(integer_queue_begin < integer_queue_end) {
        size = integer_queue_end - integer_queue_begin;
    } else if(integer_queue_begin == integer_queue_end) {
        size = 0;
    } else {
        size = integer_queue_end + INTEGER_QUEUE_SIZE - integer_queue_begin;
    }

    return size;
}

void clearing(void) {
    int k;
    int repetition = integer_queue_size();
    for(k = 0; k < repetition; k++) {
        pop_frontal();
    }

}
