#include "rufeol.h"

/*
rufeol C-1.04
Copyright 2019 Sogaya
Removing unnecessary characters from every end of line
RUFEOL (Removing Unnecessary characters From every End Of Line)

Open Watcom C32 Optimizing Compiler Version 1.8 J001
gcc (GCC) 3.4.2 (mingw-special)
Borland C++ 5.5.1 for Win32

*/

int main(int argc, char *argv[]) {
    const BOOL WITH_COMMENTS = TRUE;
    const BOOL WITHOUT_COMMENTS = FALSE;
    const int ERROR_CODE = 1;
    char CARRIAGE_RETURN[] = "-r";
    char COUNT_LF[] = "-c";
    char CRLF[] = "-CRLF";
    char DO_NOT_REMOVE_0DH[] = "-L-";
    char DO_NOT_REMOVE_TEMPORARY_BINARY_FILE[] = "-y";
    char DOUBLE_SPACED[] = "-x";
    char LEVEL_TERM[] = "-w";
    char LF[] = "-LF";
    char LINE_FEED[] = "-L";
    char MONOLITHIC[] = "-m";
    char UNNECESSARY[] = "-u";
    char VERSION_WITHOUT_COMMENTS[] = "-V";
    char VERSION_WITH_COMMENTS[] = "-VC";

    BOOL carriage_return = FALSE;
    BOOL count_LF = FALSE;
    BOOL file_to_be_read = TRUE;
    BOOL no_removing = FALSE;
    char *edge;
    char *large_buffer;
    char *q;
    char file_name[ FILE_NAME_SIZE + 1 ];
    char new_name[ FILE_NAME_SIZE + 1 ];
    int buffer_size = BUFFER_SIZE;
    int exit_code = 0;
    int file_name_size;
    int full_level = FULL_LEVEL;
    int i;
    int line_count = 0;
    int unnecessary_width = TAIL_LENGTH;
    NUMBERED o;
    NUMBERED *n = &o;
    REMOVE_FROM_LINE remove_from_line;
    REMOVE_FROM_LINE *r = &remove_from_line;

    memset(file_name, 0, FILE_NAME_SIZE + 1 );
    new_name[FILE_NAME_SIZE] = '\0';
    strncpy(new_name, RUFEOL_TEXT, FILE_NAME_SIZE);

    for(i = 1; i < argc; ++i) {
        if(! strcmp(CARRIAGE_RETURN, argv[i]) ) {
            carriage_return = TRUE;
        } else if(! strcmp(COUNT_LF, argv[i]) ) {
            count_LF = TRUE;
        } else if(! strcmp(CRLF, argv[i]) ) {
            carriage_return = TRUE;
        } else if(! strcmp(DO_NOT_REMOVE_0DH, argv[i]) ) {
            carriage_return = TRUE;
        } else if(! strcmp(DO_NOT_REMOVE_TEMPORARY_BINARY_FILE, argv[i]) ) {
            no_removing = TRUE;
        } else if(! strcmp(LF, argv[i]) ) {
            carriage_return = FALSE;
        } else if(! strcmp(LINE_FEED, argv[i]) ) {
            carriage_return = FALSE;
        } else if(! strcmp(MONOLITHIC, argv[i]) ) {
            carriage_return = TRUE;
            unnecessary_width = 2;
        } else if(! strcmp(VERSION_WITH_COMMENTS, argv[i]) ) {
            version_guide(VERSION, WITH_COMMENTS);
        } else if(! strcmp(VERSION_WITHOUT_COMMENTS, argv[i]) ) {
            version_guide(VERSION, WITHOUT_COMMENTS);
        } else {
            q = argv[i];
            edge = & q[0];

            q = strstr(argv[i], DOUBLE_SPACED);
            if(q == edge) {
                numbered(n, argv[i]);
                full_level = number(n);
                if(! strcmp(DOUBLE_SPACED, parameter(n) ) ) {
                    if(full_level == NOT_CONVERTED) {
                        full_level = FULL_LEVEL;
                    }

                    carriage_return = TRUE;
                    unnecessary_width = full_level * 2 - 1;
                    continue;
                }

                full_level = FULL_LEVEL;
            }

            q = strstr(argv[i], LEVEL_TERM);
            if(q == edge) {
                numbered(n, argv[i]);
                full_level = number(n);
                if(! strcmp(LEVEL_TERM, parameter(n) ) ) {
                    if(full_level == NOT_CONVERTED) {
                        full_level = FULL_LEVEL;
                    }

                    continue;
                }

                full_level = FULL_LEVEL;
            }

            q = strstr(argv[i], UNNECESSARY);
            if(q == edge) {
                numbered(n, argv[i]);
                full_level = number(n);
                if(! strcmp(UNNECESSARY, parameter(n) ) ) {
                    if(unnecessary_width == NOT_CONVERTED) {
                        unnecessary_width = TAIL_LENGTH;
                    }

                    continue;
                }

                unnecessary_width = TAIL_LENGTH;
            }

            if(file_to_be_read) {
                file_name[FILE_NAME_SIZE] = '\0';
                strncpy(file_name, argv[i], FILE_NAME_SIZE);
                file_to_be_read = FALSE;
            } else {
                new_name[FILE_NAME_SIZE] = '\0';
                strncpy(new_name, argv[i], FILE_NAME_SIZE);
            }

        } /* else */

    } /* for(i = 1; i < argc; ++i) */

    file_name_size = strlen(file_name);
    if(file_name_size == 0) {
        large_buffer = malloc(LARGE_BUFFER_SIZE);
        if(large_buffer == NULL) {
            fprintf(stderr, "malloc() error: %d\n", large_buffer);
            return ERROR_CODE;
        }

        line_count = standard_input_temporary_text(large_buffer, LARGE_BUFFER_SIZE);

        free(large_buffer);
        strcpy(file_name, TEMPORARY_TEXT);
    }

    if(count_LF) {
        line_count = count_lines(file_name);
        if(line_count > 0) {
            fprintf(stdout, "%d lines\n", line_count);
            exit_code = 0;
        } else {
            fprintf(stderr, "count_lines() error: %s\n", file_name);
            exit_code = ERROR_CODE;
        }

        return exit_code;
    }

    if(! setting(r, file_name, new_name, buffer_size, full_level, unnecessary_width, no_removing) ) {
        return ERROR_CODE;
    }

    if(carriage_return) {
        exit_code = insert_CRLF(r);
    } else {
        exit_code = insert_LF(r);
    }

    release(r);
    if(line_count > 0) {
        if(! no_removing) {
            remove(TEMPORARY_TEXT);
        }

    }

    return exit_code;
}
